C  SUBROUTINE EXTRA1 to sum statistics and maximum values 3/31/2000
      SUBROUTINE EXTRA1(JJ,op,iyear,J) 
      REAL mswidth,mswall
c               25         12          24            11
      COMMON/A/wall(1000),sizz(1000),wallrev(1000),sizerev(1000)
     +,calcN(100),realN(100),estn(100),estw(100),realnos(100),
     +realw(100),icln,rep,mswidth,mswall,nreal,MISSRING(100)
      COMMON/SUMS/
     +nnring,   !3*Number of ring pairs without one of them missing
     +summsr,   !1*Sum squares replicate measurements of ring width(crn files)
     +summsw,   !2*Sum squares replicate measurements wall thickness(crn filis)
     +snn,      !23*Sum of normalized measured cells averaged over replicates
     +sumn,     !4*Sum of measured cell replicates for cell width analysis
     +sumnw,    !5*Number of rings used for wall thickness analysis
     +sunww,    !36*Sum of measured walls which have replicate measurements
     +sunnw,    !6*Number of replicates with wall thickness measurements
     +sumrepw,  !7*Sum of replications of wall thickness measurements
     +sumrep,   !9*Sum of number of all replications
     +sumest,   !13*Sum normalized cell size estimates
     +sumwest,  !26*Sum estimated wall thicknesses (when actual replicates)
     +sumsqest, !16*Sum squares normalized cell size estimates
     +sumsqwest,!29*Sum sq. estimated wall thick. (when actual replicates exist)
     +sumszrel, !14*Sum size of actual wall measurements
     +sumreal,  !8*Sum of ring width measurements
     +sqreal,   !17*Sum sq. averaged measured cell widths
     +sqwreal,  !30*Sum sq. averaged real wall measurements (when replicated)
     +sumwreal, !27*Sum real wall measurements (when actual replicates exist)
     +sumdsz,   !15*Sum estimated-actual differences cell sizes (residuals)
     +sumdwa,   !28*Sum residuals of wall thickness
     +sqdsz,    !18*Sum squares of residuals for cell sizes
     +sqdwa,    !31*Sum squares residuals for wall thickness
     +rszmax,   !22*Absolute velue max of cell size residuals
     +rwamax,   !35*Absolute value max of wall thickness resicuals
     +xy,       !19*Sum of cross products of measured and estimated cell sizes
     +xywall,   !32*Sum of cross products of measured and estimated wall thick
     +termax,   !20*Maximum estimated cell size
     +tewmax,   !33*Maximum estimated wall thickness
     +tarmax,   !21*Maximum measured average (over replicates) of cell sizes
     +tawmax,   !34*Maximum measured average (over replicates) of wall thick
     +termin,   !20*Minimum estimated cell size
     +tewmin,   !33*Minimum estimated wall thickness
     +tarmin,   !21*Minimum measured average (over replicates) of cell sizes
     +tawmin    !34*Minimum measured average (over replicates) of wall thick
      INTEGER  op(40)
C  *************************************************************************     
CC Set sums to 0
C  *************************************************************************     
      IF(J.EQ.1)THEN
c	  nnring=0
        summsr=0. !1*sum of squares of replicate cell sizes
        summsw=0. !2*sum of squares of replicate wall thichness
        nnring=0  !3*number of rings
        snn=0.0   !23*sum of numbers of normalized cells
        sumn=0.0  !4*sum of numbers of cells including the replications
        sumnw=0.0 !5*number of rings with wall measurements
c      Calculations for rings where there are wall thickness measurements
        sunww=0.0 !36*number of normalized wall thicknesses with measurements
        sunnw=0.0 !6*number of replicates and cells where wall measurements exist
        sumrepw=0.0 !7*sum of replicate numbers where wall thicknesses exist
c      Calculations for all rings
        sumreal=0.0 !8*
        sumrep=0.0  !9*
        sumest=0.0   !13*Sum normalized cell size estimates
        sumwest=0.0  !26*Sum estimated wall thicknesses (when actual replicates)
        sumsqest=0.0 !16*Sum squares normalized cell size estimates
        sumsqwest=0.0!29*Sum sq. estimated wall thick. (when actual replicates exist)
        sumszrel=0.0 !14*Sum size of actual wall measurements
        sumreal=0.0  !8*Sum of ring width measurements
        sqreal=0.0   !17*Sum sq. averaged measured cell widths
        sqwreal=0.0  !30*Sum sq. averaged real wall measurements (when replicated)
        sumwreal=0.0 !27*Sum real wall measurements (when actual replicates exist)
        sumdsz=0.0   !15*Sum estimated-actual differences cell sizes (residuals)
        sumdwa=0.0   !28*Sum residuals of wall thickness
        sqdsz=0.0    !18*Sum squares of residuals for cell sizes
        sqdwa=0.0    !31*Sum squares residuals for wall thickness
        rszmax=0.0   !22*Absolute value max of cell size residuals
        rwamax=0.0   !35*Absolute value max of wall thickness residuals
        xy=0.0       !19*Sum of cross products of measured and estimated cell sizes
        xywall=0.0   !32*Sum of cross products of measured and estimated wall thick
        termax=0.0   !20*Maximum estimated cell size
        tewmax=0.0   !33*Maximum estimated wall thickness
        tarmax=0.0   !21*Maximum measured average (over replicates) of cell sizes
        tawmax=0.0   !34*Maximum measured average (over replicates) of wall thick
        termin=99999. !20*Minimum estimated cell size
        tewmin=99999. !33*Minimum estimated wall thickness
        tarmin=99999. !21*Minimum measured average (over replicates) of cell sizes
        tawmin=99999. !34*Minimum measured average (over replicates) of wall thick
       ENDIF
      summsr=summsr+mswidth*icln*rep !1 (see IF above for variable names)
      summsw=summsw+mswall*icln*rep  !2
      nnring=nnring+1                   !3
      sumn=sumn+icln*rep             !4
c      Calculations for rings where there are wall thickness measurements
      IF(mswall.GT.0)THEN
        sumnw=sumnw+1  !Number of rings with wall measurements !5
        sunnw=sunnw+icln*rep !number of replicates where wall measurement!6
        sumrepw=sumrepw+rep  !sum of replicate numbers where wall exist !7
      ENDIF
      sumreal=sumreal+ realN(JJ) !sum of ring widths !8
c      Calculations for all rings
      sumrep=sumrep+rep                 !9
C  *************************************************************************     
CC Calculate more statistics
C  *************************************************************************     
c                  10      11    12    13      14       15     16
      CALL CALCST(nreal,sizerev,sizz,sumest,sumszrel,sumdsz,sumsqest,
     +     sqreal,sqdsz,xy,termax,tarmax,rszmax,snn,termin,tarmin)
c            17    18   19   20     21     22    23
      IF(mswall.GT.0)THEN
c                    10      24    25     26      27      28
        CALL CALCST(nreal,wallrev,wall,sumwest,sumwreal,sumdwa,
     +  sumsqwest,sqwreal,sqdwa,xywall,tewmax,tawmax,rwamax,sunww,
     +  tewmin,tawmin)
c          29        30     31    32     33      34    35     36
        IF(TERMIN.EQ.0.)THEN
	    IMIKE=JJ
	    IYMIKE=IYEAR
	  ENDIF
      ENDIF
      RETURN
      END

C  SUBROUTINE EXTRA2 to calculate statistics and run iterations.
      SUBROUTINE EXTRA2(IIGO,IERR,ITI,NITI,DELTA,MO,LO,VARNEW,OP,NOVAR,
     +ITIF,JJ,NTOT,begyear,endyear,clfile,srz,csfile,nnx)
      REAL mswidth,mswall
c               25         12          24            11
      COMMON/A/wall(1000),sizz(1000),wallrev(1000),sizerev(1000)
     +,calcN(100),realN(100),estn(100),estw(100),realnos(100),
     +realw(100),icln,rep,mswidth,mswall,nreal,MISSRING(100)
      COMMON/CHRN/chr(100),chrest(100),ICHRMS(100)
      COMMON/SUMS/
     +nnring,   !3*Number of ring pairs without one of them missing
     +summsr,   !1*Sum squares replicate measurements of ring width(crn files)
     +summsw,   !2*Sum squares replicate measurements wall thickness(crn filis)
     +snn,      !23*Sum of normalized measured cells averaged over replicates
     +sumn,     !4*Sum of measured cell replicates for cell width analysis
     +sumnw,    !5*Number of rings used for wall thickness analysis
     +sunww,    !36*Sum of measured walls which have replicate measurements
     +sunnw,    !6*Number of replicates with wall thickness measurements
     +sumrepw,  !7*Sum of replications of wall thickness measurements
     +sumrep,   !9*Sum of number of all replications
     +sumest,   !13*Sum normalized cell size estimates
     +sumwest,  !26*Sum estimated wall thicknesses (when actual replicates)
     +sumsqest, !16*Sum squares normalized cell size estimates
     +sumsqwest,!29*Sum sq. estimated wall thick. (when actual replicates exist)
     +sumszrel, !14*Sum size of actual wall measurements
     +sumreal,  !8*Sum of ring width measurements
     +sqreal,   !17*Sum sq. averaged measured cell widths
     +sqwreal,  !30*Sum sq. averaged real wall measurements (when replicated)
     +sumwreal, !27*Sum real wall measurements (when actual replicates exist)
     +sumdsz,   !15*Sum estimated-actual differences cell sizes (residuals)
     +sumdwa,   !28*Sum residuals of wall thickness
     +sqdsz,    !18*Sum squares of residuals for cell sizes
     +sqdwa,    !31*Sum squares residuals for wall thickness
     +rszmax,   !22*Absolute velue max of cell size residuals
     +rwamax,   !35*Absolute value max of wall thickness resicuals
     +xy,       !19*Sum of cross products of measured and estimated cell sizes
     +xywall,   !32*Sum of cross products of measured and estimated wall thick
     +termax,   !20*Maximum estimated cell size
     +tewmax,   !33*Maximum estimated wall thickness
     +tarmax,   !21*Maximum measured average (over replicates) of cell sizes
     +tawmax,    !34*Maximum measured average (over replicates) of wall thick
     +termin,   !20*Minimum estimated cell size
     +tewmin,   !33*Minimum estimated wall thickness
     +tarmin,   !21*Minimum measured average (over replicates) of cell sizes
     +tawmin    !34*Minimum measured average (over replicates) of wall thick
      COMMON/COITER/ AITI(3), VAR(3), PIT(10), VAROLD(10), AITIOLD(10),
     +NNOLD(10),NNITI(3),isave(5),BEGVAR
      COMMON/PARMS/  p(60), b(100), zini(100), den(5),piso(40),
     + rmc(3),rmt(3),grc(5),gc(5),prp(3),upt(5),xrmn(5),xrmx(5)
      INTEGER  op(40), begyear, endyear 
      CHARACTER CLFILE*8,ANS*1,csfile*8
      IF(op(13).NE.1.AND.op(1).GT.1)THEN ! IF Iteration <1 ALSO PRINT
C  *************************************************************************     
CC Write Headings to STAT.out file
C  *************************************************************************     
C  *************************************************************************     
C    Creates file with statistical output data "Stat.dat"
C  *************************************************************************     
        OPEN(33,FILE=clfile(1:4)//'stat.dat')
        WRITE(33,'('' FILE STATISTICAL DATA  '',I4,'' - '',I4,
     +'' FOR '',A8,'' ITERATION STEP '',I2,'' ITER NO '',I1)')begyear,
     +   endyear,csfile,ITI,NITI
        CALL DATETIME(33)
      WRITE(33,'('' Year  Ring W Est  Ring W Act  Est-Act   Cell # Est '
     +','' Cell # Act  Est-Act '')')
C  *************************************************************************     
CC Write yearly ring width and cell number data to STAT.out file
C  *************************************************************************     
        DO I=1,JJ
         WRITE(33,51)op(29)-1+I,EstN(i),RealN(i),EstN(i)-RealN(i),
     +    EstW(i),Realnos(i),EstW(i)-Realnos(i)
        END DO
 51     FORMAT(i4,2f12.2,f10.2,2f12.2,f10.2)
 53     FORMAT(' Act Y mm ',5F8.3,3E10.3)
 54     FORMAT(' Est X mm ',4F8.3,' Observations present:',i8)
 55     FORMAT(' Diff  Y-X',10F8.3)
 56     FORMAT(' Ratio Y/X',10F8.3)
 57     FORMAT(' Residual ',10F8.3)
 157    FORMAT(' Residual ',3F8.3,' Replication: ',F6.2)
      ENDIF
	IF(OP(13).GT.0)THEN
C      ELSE ! With Iteration
        IF(nnring.LT.nnx)nnx=nnring
        IF(OP(16).EQ.6)THEN ! For Index Data alone
          srz=0
          RETURN
        ELSEIF(op(16).EQ.8)THEN ! For Index data with selected other data
          srz=0
          GOTO 558  
        ENDIF
      ENDIF
      srz=0
C  *************************************************************************     
CC Calculate Statistics for Ring-Width data
C  *************************************************************************     
      CALL STAT(JJ,EstN,Realn,xmean,ymean,rmean,xsd,ysd,rsd,corr1,
     +axy,bxy,sees,sx,sy,sqx,sqy,sxy,MISSRING,NS,ringmax,ringamax,rmax,
     +OP(12),ringmin,ringamin)
      IF(op(13).NE.1)THEN
        Write(33,'(/'' RING WIDTH ANALYSIS (mm)'')')
        Write(33,52)
        Write(33,53)ymean*.001,ysd*.001,ringamax*.001,ringamin*.001,
     +  corr1,axy*.001,bxy,sees*.001
        Write(33,54)xmean*.001,xsd*.001,ringmax*.001,ringmin*.001,NS
        Write(33,55)(ymean-xmean)*.001,(ysd-xsd)*.001,(ringamax-ringmax)
     +  *.001
        Write(33,56)ymean/xmean,ysd/xsd,ringamax/ringmax
        Write(33,57)rmean*.001,rsd*.001,rmax*.001
	ENDIF
	IF(OP(13).GT.0)THEN
        IF(op(16).EQ.1.OR.op(16).EQ.5.OR.op(16).EQ.7.OR.op(16)
     +   .EQ.9)THEN !With iteration for Ring Width Analysis
         rz=ABS(rmean)
         IF(op(17).EQ.1)rz=rsd+ABS(rmean)
         IF(op(17).EQ.2)rz=1.-corr1**2
         IF(op(17).EQ.3)rz=(rsd+ABS(rmean))/ysd
         IF(op(17).EQ.4)rz=ABS(ringamax-ringmax)
         AITI(ITI)=rz
         NNITI(ITI)=nnring
          IF(op(16).EQ.1)THEN
           CALL ITERATE(ITI,NITI,DELTA,MO,LO,VARNEW,op,
     +       nnring,NOVAR,ITIF,nnx)
           goto 96
          ELSE
           srz=srz+rz
          ENDIF
	  ENDIF 
      ENDIF
C  *************************************************************************     
CC Calculate Statistics for Cell Number data
C  *************************************************************************     
      CALL STAT(JJ,EstW,Realnos,xmean,ymean,rmean,xsd,ysd,rsd,corr2,
     +axy,bxy,sees,sx,sy,sqx,sqy,sxy,MISSRING,NS,ringwmax,realnomx,rmax,
     +OP(12),ringwmin,realnomi)
      IF(op(13).NE.1)THEN
        Write(33,'(/'' CELL NUMBER IN THE RING '')')
        Write(33,52)
 58     FORMAT(' Act Y mu ',5F8.3,3E10.3)
 59     FORMAT(' Est X mu ',4F8.3,' Observations present',i4)
159     FORMAT(' Est X mu ',4F8.3,' Observations present',
     .   F8.0)
        Write(33,58)ymean,ysd,realnomx,realnomi,corr2,axy,bxy,sees
        Write(33,59)xmean,xsd,ringwmax,ringwmin,NS
        Write(33,55)ymean-xmean,ysd-xsd,realnomx-ringwmax
        Write(33,56)ymean/xmean,ysd/xsd,realnomx/ringwmax
        Write(33,57)rmean,rsd,rmax
C     X IS ESTIMATES, Y IS ACTUAL CELL SIZES
C  *************************************************************************     
CC Assemble statistics for Iteration of Cell Sizes
C  *************************************************************************     
      ENDIF
      IF(OP(13).GT.0)THEN
	  IF(op(16).EQ.2.OR.op(16).EQ.5.OR.op(16).EQ.7.OR.op(16)
     +   .EQ.9)THEN
         rz=ABS(rmean)
         IF(op(17).EQ.1)rz=rsd+ABS(rmean)
         IF(op(17).EQ.2)rz=1.-corr2**2
         IF(op(17).EQ.3)rz=(rsd+ABS(rmean))/ysd
         IF(op(17).EQ.4)rz=ABS(realnomx-ringwmax)
         AITI(ITI)=rz
         NNITI(ITI)=nnring
         IF(op(16).EQ.2)THEN
         CALL ITERATE(ITI,NITI,DELTA,MO,LO,VARNEW,op,
     +    nnring,NOVAR,ITIF,nnx)     
            goto 96
         ELSE
           srz=srz+rz
           IF(op(16).EQ.9)RETURN 
         ENDIF
	  ENDIF
      ENDIF
      IF(op(13).GT.0.AND.op(1).GT.1.AND.op(15).EQ.9)RETURN
 558  REP=SUMREP/nreal ! Average replication
C  *************************************************************************     
CC Calculate Statistics for Cell Size data
C  *************************************************************************     
      CALL STAT2(snn,XMEAN,YMEAN,RMEAN,XSD,YSD,RSD,R1,A,bcoef,SEES,
     +SUMEST,SUMSZREL,SUMSQEST,SQREAL,XY,SUMDSZ,SQDSZ,OP(12))
      IF(op(13).NE.1)THEN
        Write(33,'(/'' INDIVIDUAL CELL SIZES FOR ALL RINGS (mkm)'')')
        Write(33,52)
 52   FORMAT(' Variable   Mean  St. Dev.   Max     Min  Correlation   A 
     +    Bxy  Adj.Std.Err.Est')
        Write(33,58)ymean,ysd,tarmax,tarmin,r1,a,bcoef,sees
        Write(33,159)xmean,xsd,termax,termin,snn
        Write(33,55)ymean-xmean,ysd-xsd,tarmax-termax
        IF(XMEAN*YMEAN*XSD*YSD*TERMAX*TARMAX.NE.0)
     +    Write(33,56)ymean/xmean,ysd/xsd,tarmax/termax
        Write(33,157)rmean,rsd,rszmax,rep
        IF(SUMN.NE.0)REPMS=SQRT(SUMMSR/SUMN)!SSq of Rep MS/numb of replicates
        IF(REP.GT.0)STDERR=REPMS/SQRT(REP)
        IF(STDERR.NE.0)Write(33,60)REPMS,STDERR,SEES/STDERR
 60     Format(' SD Reps:',F8.4,' St Err Reps:',F8.5,
     +  ' St Err Est/St Err Reps',F9.5)
C  *************************************************************************     
CC Assemble statistics for Iteration Cell Sizes
C  *************************************************************************
      ENDIF
	IF(OP(13).GT.0)THEN     
        IF(op(16).EQ.3.OR.op(16).EQ.5.OR.op(16).EQ.7.OR.op(16).EQ.8)
     +   THEN
         rz=ABS(rmean)
         IF(op(17).EQ.1)rz=rsd+ABS(rmean)
         IF(op(17).EQ.2)rz=1.-R1**2
         IF(op(17).EQ.3)rz=(rsd+ABS(rmean))/ysd
         IF(op(17).EQ.4)rz=ABS(tarmax-termax)
         AITI(ITI)=rz
         NNITI(ITI)=nnring
         IF(op(16).EQ.3)THEN
           Call ITERATE(ITI,NITI,DELTA,MO,LO,VARNEW,op,
     +     nnring,NOVAR,ITIF,nnx)           
           goto 96
         ELSE
           srz=srz+rz
         ENDIF
	  ENDIF
      ENDIF
C  *************************************************************************     
CC Calculate Statistics for Wall Thickness data
C  *************************************************************************     
      CALL STAT2(sunww,XMEAN,YMEAN,RMEAN,SDX,SDY,RSD,R2,A,Bcoef,SEES,
     +SUMWEST,SUMWREAL,SUMSQWEST,SQWREAL,XYWALL,SUMDWA,SQDWA,OP(12))
c
      IF(op(13).NE.1)THEN
      Write(33,'(/'' INDIVIDUAL CELL WALL THICKNESSES FOR ALL RINGS (mkm
     +)'')')
        Write(33,52)
C 52   FORMAT(' Variable   Mean  St. Dev.  Max  Correlation    A    Bxy
        Write(33,58)ymean,sdy,tawmax,tawmin,r2,a,bcoef,sees
        Write(33,159)xmean,sdx,tewmax,tewmin,sunww
        Write(33,55)ymean-xmean,sdy-sdx,tawmax-tewmax
        IF(XMEAN*YMEAN*SDX*SDY*TEWMAX*TAWMAX.NE.0)
     +   Write(33,56)ymean/xmean,sdy/sdx,tawmax/tewmax
        Write(33,157)rmean,rsd,rwamax,rep
        IF(SUMMSW.GT.0.AND.SUMN.GT.0)REPMS=SQRT(SUMMSW/SUMN)
        IF(REP.GT.0)STDERR=REPMS/SQRT(REP)
        IF(STDERR.GT.0)Write(33,60)REPMS,STDERR,SEES/STDERR
c        CLOSE(33)
C  *************************************************************************     
CC Assemble statistics for Iteration Wall Thicknesses
C  *************************************************************************
      ENDIF
	IF(OP(13).GT.0)THEN     
        IF(op(16).EQ.4.OR.op(16).EQ.5.OR.op(16).EQ.7.OR.op(16).EQ.8)
     +   THEN
         rz=ABS(rmean)
         IF(op(17).EQ.1)rz=rsd+ABS(rmean)
         IF(op(17).EQ.2)rz=1.-R2**2
         IF(op(17).EQ.3)rz=(rsd+ABS(rmean))/ysd
         IF(op(17).EQ.4)rz=ABS(tawmax-tewmax)
         IF(op(16).EQ.4)THEN
           AITI(ITI)=rz
           NNITI(ITI)=nnring
         ELSE
           srz=srz+rz
           IF(op(16).EQ.7.OR.op(16).EQ.8)RETURN 
           AITI(ITI)=srz
           NNITI(ITI)=nnring
         ENDIF
         CALL ITERATE(ITI,NITI,DELTA,MO,LO,VARNEW,op,
     +     nnring,NOVAR,ITIF,nnx)
	   GOTO 96
	  ENDIF
	ENDIF
C  *************************************************************************     
CC Not iterating, RETURN
C  *************************************************************************     
      IF(OP(13).EQ.0)RETURN
            
96    IF(ITI.GT.0)THEN
        IF(ITI.EQ.5)THEN
          IIGO=3 !  Iteration terminated abnormally
		JJ=0    
          RETURN
        ENDIF
C  *************************************************************************     
CC Finished a step in iteration, now update the value of the interated variable
C  *************************************************************************     
        CALL CHANGE(op,ierr,ITI,VARNEW)
        IF(IERR.NE.0)THEN
          IIGO=2 ! Variable out of range
          RETURN
        ENDIF
C  *************************************************************************     
CC Iteration complete, write output to file Iteration.out
C  *************************************************************************     
        IF(ITI.EQ.4)THEN
          WRITE(52,'(/'' FINISHED ITERATION (A) ITI='',I2,'' Parameter''
     +,2I3,'' with optimized value:'', E14.8,/,
     +'' Sq Mean or MS Residual'',E12.6,'' with'',I4,
     +'' replications and'',I4,'' iterations.''/ ''  Diff: '',E12.6/
     +'' Control '',2I3,''  MAKE LAST CALCULATIONS?'')')ITI,
     +op(14),op(15),var(2),AITI(2),NNITI(2),NITI,AITI(2)-BEGVAR,op(16),
     +op(17)
           ITI=0
            IF(ierr.NE.0)THEN
         WRITE(52,'('' ERROR'',I2,'' ENCOUNTERD!!'')')IERR
         WRITE(*,'('' ERROR'',I2,'' ENCOUNTERD!!'')')IERR
             IIGO=2 ! Variable out of range
             RETURN
           ENDIF
C  *************************************************************************     
CC Iteration complete, write output to screen
C  *************************************************************************     
           WRITE(*,'(/'' FINISHED ITERATION (A) ITI='',I2,'' Parameter''
     +,2I3,'' with optimized value:'', E14.8,/,
     +'' Sq Mean or MS Residual'',E12.6,'' with'',I4,
     +'' replications and'',I4,'' iterations.   Diff: '',E12.6/
     +'' Control '',2I3,''  MAKE LAST CALCULATIONS?'')')ITI,
     +op(14),op(15),var(2),AITI(2),NNITI(2),NITI,AITI(2)-BEGVAR,op(16),
     +op(17)
           WRITE(*,'('' Enter a RETURN to Run Program with Change or "E"
     + to exit.'')')
c	 goto 1999  !temporary for debug
           READ(*,'(A1)')ANS
C  *************************************************************************     
CC Enter 'E' to EXIT and not recalculate with plots and files
C  *************************************************************************     
            IF(ANS.EQ.'e'.OR.ANS.EQ.'E')THEN
             IIGO=1
             NTOT=1
             RETURN ! Exit
           ENDIF
        ENDIF
C  *************************************************************************     
CC Prepare for running full program one last time without iterating
C  *************************************************************************     
1999        WRITE(Clfile(5:8),'(i4)')begyear
        NTOT=1
        IIGO=4 ! Option to return to the top of the program
        RETURN
      ENDIF
c   ITI EQ 0
999   IIGO=5 ! Exit Program
      RETURN
      END

      SUBROUTINE CHRON(op,IDCRN,NCHYR,BEGYEAR,ENDYEAR,srz,ITI,NITI,DELTA
     +,MO,LO,VARNEW,NOVAR,ITIF,IIGO,IERR,CLFILE,NTOT,NNRING,nnx)
      COMMON/CHRN/chr(100),chrest(100),ICHRMS(100)
      COMMON/COITER/AITI(3),VAR(3),PIT(10),VAROLD(10),AITIOLD(10),
     +NNOLD(10),NNITI(3),isave(5),BEGVAR
      INTEGER BEGYEAR, ENDYEAR, op(40)
      CHARACTER IDCRN*6,clfile*8,ANS*1 
        SX=0.
        SY=0. 
        DO 1 I=1,NCHYR
          SX=SX+CHREST(I)
          SY=SY+CHR(I) 
  1     CONTINUE 
        SX=SX/NCHYR
        SY=SY/NCHYR
c      WRITE(*,'('' Mean Est. Width= '',E10.3,'' Mean Index= '',E10.3)')
c     +SX,SY 
C      PAUSE
        ainmax=0
        einmax=0
        ainmin=99999.
	  eimin=099999.
        IF(op(13).NE.1)THEN
          WRITE(33,'(/'' Analysis of Ring Width Index ''/
     +    '' Year  Estimate  Actual  Est - Actual Index '')')
        ENDIF
        DO 2 I=1,NCHYR
          J=I+BEGYEAR-1
          CHREST(I)=CHREST(I)/SX
          IF(CHREST(I).GT.einmax)einmax=chrest(i)
          IF(CHREST(I).LT.einmin)einmin=chrest(i)
          IF(CHR(I).GT.ainmax)ainmax=chr(i)
          IF(CHR(I).LT.ainmin)ainmin=chr(i)
          IF(op(13).NE.1)THEN
            WRITE(33,'(I5,3F9.3)')J,CHREST(I),CHR(I),CHREST(I)-CHR(I)
          ENDIF
  2     CONTINUE 
C      ELSE
C        RETURN
C      ENDIF
C     FROM EXTRA2 FOR RING WIDTH
 51   FORMAT(i4,2f12.2,f10.2,2f12.2,f10.2)
 52   FORMAT(' Variable   Mean  St. Dev.  Max    Min    Correlation     
     +A     Bxy  Adj.Std.Err.Est')
 53   FORMAT(' Act Indx ',5F8.3,3E10.3)
 54   FORMAT(' Est Indx ',4F8.3,' Number of observations present:',i8)
 55   FORMAT(' Diff  Y-X',10F8.3)
 56   FORMAT(' Ratio Y/X',10F8.3)
 57   FORMAT(' Residual ',10F8.3)
 157  FORMAT(' Residual ',3F8.3,' Replication: ',F6.2)
      CALL STAT(NCHYR,CHREST,CHR,xmean,ymean,rmean,xsd,ysd,rsd,corr1,
     +axy,bxy,sees,sx,sy,sqx,sqy,sxy,ICHRMS,NS,ringmax,ringamax,rmax,
     +OP(12),ringmin,ringamin)
      IF(op(13).NE.1)THEN !Changed from LT to NE 12/9/00
        Write(33,'(/'' RING WIDTH INDEX WITH '',A6,I6,'' - '',I4)')IDCRN
     +  ,begyear,endyear
        Write(33,52)
        Write(33,53)ymean,ysd,ainmax,ainmin,corr1,axy,
     +    bxy,sees
        Write(33,54)xmean,xsd,einmax,einmin,NCHYR
        Write(33,55)(ymean-xmean),(ysd-xsd),(ainmax-einmax)
        Write(33,56)ymean/xmean,ysd/xsd,ainmax/einmax
        Write(33,57)rmean,rsd,rmax
	ENDIF
	IF(OP(13).GT.0)THEN
         IF(op(16).GT.5)THEN
         rz=ABS(rmean)
         IF(op(17).EQ.1)rz=rsd+ABS(rmean)
         IF(op(17).EQ.2)rz=1.-corr1**2
         IF(op(17).EQ.3)rz=(rsd+ABS(rmean))/ysd
         IF(op(17).EQ.4)rz=ABS(ainmax-einmax)
         AITI(ITI)=rz
         NNITI(ITI)=nnring
         srz=srz+rz
         IF(op(16).EQ.7.OR.op(16).EQ.8.OR.op(16).EQ.9)THEN
	     AITI(ITI)=srz
           NNITI(ITI)=nnring
	   ENDIF
         CALL ITERATE(ITI,NITI,DELTA,MO,LO,VARNEW,op,
     +     nnring,NOVAR,ITIF,nnx)
	   ENDIF
      ELSE
        RETURN
      ENDIF
96    IF(ITI.GT.0)THEN
        IF(ITI.EQ.5)THEN
          IIGO=3
          RETURN
        ENDIF
        IF(ITI.NE.4) CALL CHANGE(op,ierr,ITI,VARNEW)
        IF(ITI.EQ.4)THEN
          WRITE(52,'(/'' FINISHED ITERATION B, ITI=''I2,''. Parameter ''
     +,2I3,'' optimized value:'', E14.8/
     +'' Sq Mean or MS Residual'',E12.6,'' with'',I4,'' replications'', 
     +'' and'',I4,'' iterations.'',
     +'' Dif: '',E12.6/
     +'' Control '',2I3,'' Error if any is '',I2)')ITI,
     +op(14),op(15),var(2),AITI(2),NNITI(2),NITI,AITI(2)-BEGVAR,op(16),
     +op(17),ierr
           ITI=0
        IF(IERR.NE.0)THEN
         WRITE(52,'('' ERROR'',I2,'' ENCOUNTERD!!'')')IERR
         WRITE(*,'('' ERROR'',I2,'' ENCOUNTERD!!'')')IERR
          IIGO=2
          RETURN
        ENDIF
           WRITE(*,'(/'' FINISHED ITERATION B.  Parameter '',2I3,
     +'' with optimized value:'', E14.8,/,
     +'' Sq Mean or MS Residual'',E12.6,'' with'',I4,'' replications'', 
     +'' and'',I4,'' iterations.'',
     +'' Dif: '',E12.6/
     +'' Control '',2I3,''  MAKE LAST CALCULATIONS?''/
     + '' Enter a RETURN to Run Program with Change or "E" to exit.'')')
     +op(14),op(15),var(2),AITI(2),NNITI(2),NITI,AITI(2)-BEGVAR,op(16),
     +op(17)
           READ(*,'(A1)')ANS
           IF(ANS.EQ.'e'.OR.ANS.EQ.'E')THEN
             IIGO=1
             RETURN
           ENDIF
        ENDIF
        WRITE(Clfile(5:8),'(i4)')begyear
        NTOT=1
        IIGO=4
        RETURN
      ENDIF
999   IIGO=5
      RETURN
      
      END