C      3/31/2000
C  *************************************************************************     C    Reads Cambial Parameters in file Cmb2000.par 3/31/2000
C  *************************************************************************     
      SUBROUTINE CMBPAR(B,K)
      REAL      b(100)
      INTEGER   k(10)
      OPEN(10,STATUS='OLD',FILE='camb70.par',ERR=1)
	READ(10,*)
	READ(10,*)
      READ(10,'(I4)')(k(I),i=1,10)
	READ(10,*)
	READ(10,'(F10.3)')(b(i),i=1,20)
	READ(10,*)
	READ(10,'(F10.3)')(b(i),i=21,41)
	READ(10,*)
	READ(10,'(F10.3)')(b(i),i=42,60)
	READ(10,*)
	READ(10,'(F10.3)')(b(i),i=61,80)
	READ(10,*)
	READ(10,'(F10.3)')(b(i),i=81,100)
C	ii=j*20
C	i1=ii+1
C	i2=ii+20
c	   READ(10,'(F10.3)')b(i+j*20)
C	   READ(10,'(F10.3)')(b(i),i=i1,i2)
c	  ENDDO
c      ENDDO
      CLOSE(10)
      RETURN
 1    WRITE(*,'(1x,'' File '',A12,'' is absent'')')'camb70.par'
      PAUSE
      RETURN
      END

C  *************************************************************************     
C    Reads Cambial initiation data if file is present or creates default if not
C  *************************************************************************     
      SUBROUTINE cmbini(b,ch,state,num)
      REAL           b(100), ch(10,1000)
	INTEGER        num(4)
      CHARACTER      state*1(1000)
C  *************************************************************************     
C    Creates default initial conditions so all runs can begin with same conditions
C  *************************************************************************     
C        initial conditions - 1 initial cell
	ch=0.0
	state=' '
      num(1)=1  !Number in the ring = 1
      num(2)=1  !Number in the division layer = 1
      num(3)=0  !Other zones have no cells
      num(4)=0  !Other zones have no cells
	ch(8,1)=b(13)/1.4 ! Size is 7.14 when dividing size is 10.
!                         Almost ready to divide.
	ch(9,1)=b(7) !Wall is minimum cell wall thickness
      state(1)='c'
      RETURN
      END
