c   Program CALCSTatistics   Harold Fritts 3/31/2000
      SUBROUTINE CALCST(N,X,Y,SX,SY,SR,SQX,SQY,SQR,SXY,XMAX,YMAX,RMAX,
     +SNN,XMIN,YMIN)
      REAL X(1000),Y(1000)
C     SX,SY,SQX,SQY,SXY,SR,SQR
C     ***********************************************************************
C     X IS ALWAYS THE ESTIMATED VALUE, Y IS ALWAYS THE MEASURED OR ACTUAL VALUE
C     ***********************************************************************
C     SX,SY,SQX,SQY,SXY are sums, sums of squares and sum of product,
C     N is length of series x and y while N1 is the nunber of values in 
C     summed sequence beginning with the first value and ending with last   
C     value in each series, SR and SQR are sums and sum squares of residuals
C     XMAX,YMAX are Maxima of the respective series and RMAX is the absolute 
C     value of the maximum residual. 
      IF(SNN.EQ.0)THEN
        SX=0
        SY=0
        SQX=0
        SQY=0
        SXY=0
        SR=0
        SQR=0
C        YMAX=0
C        RMAX=0
C	  XMIN=99999.0
C	  YMIN=99999.0 
      ENDIF
C
c      N1=N1-1
      DO 10 I=1,N                ! Do over number of observations (N)
       SNN=SNN+1                 ! Summing the number of observations
       SX=SX+X(I)                ! Sum of X variable
       IF(XMAX.LT.X(I))XMAX=X(I) ! Max for X calculated
	      IF(X(I).EQ.0.)THEN
	       MIKE=I
	      ENDIF

       IF(XMIN.GT.X(I))XMIN=X(I) ! Min for X calculated
       SY=SY+Y(I)                ! Sum of Y variable
       IF(YMAX.LT.Y(I))YMAX=Y(I) ! Max for Y calculated
       IF(YMIN.GT.Y(I))YMIN=Y(I) ! Min for Y calculated
       SQX=SQX+X(I)**2           ! Sum of squares of X variable
       SQY=SQY+Y(I)**2           ! Sum of squares of Y variable
       SXY=SXY+X(I)*Y(I)         ! Cross product term (Sum of X times Y)
       SR=SR+(Y(I)-X(I))         ! Sum of differences between X and Y
       IF(RMAX.LT.ABS(X(I)-Y(I)))RMAX=ABS(X(I)-Y(I)) ! Max Residual
       SQR=SQR+((Y(I)-X(I))**2) ! Square of differences X and Y
10    CONTINUE
      RETURN
      END